"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class InterpretedGenomeRD(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "analysisId",
        "companyName",
        "interpretationRequestId",
        "referenceDatabasesVersions",
        "reportUri",
        "reportUrl",
        "reportedVariants",
        "softwareVersions",
        "versionControl",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_4_0_0 import reports as reports_4_0_0

        return {
            "reportedStructuralVariants": reports_4_0_0.ReportedStructuralVariant,
            "reportedVariants": reports_4_0_0.ReportedVariant,
            "versionControl": reports_4_0_0.ReportVersionControl,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_4_0_0 import reports as reports_4_0_0

        return {
            "org.gel.models.report.avro.ReportedStructuralVariant": reports_4_0_0.ReportedStructuralVariant,
            "org.gel.models.report.avro.ReportedVariant": reports_4_0_0.ReportedVariant,
            "org.gel.models.report.avro.ReportVersionControl": reports_4_0_0.ReportVersionControl,
            "org.gel.models.report.avro.InterpretedGenomeRD": reports_4_0_0.InterpretedGenomeRD,
        }

    __slots__ = [
        "analysisId",
        "companyName",
        "interpretationRequestId",
        "referenceDatabasesVersions",
        "reportUri",
        "reportUrl",
        "reportedVariants",
        "softwareVersions",
        "versionControl",
        "comments",
        "reportedStructuralVariants",
    ]

    def __init__(
        self,
        analysisId,
        companyName,
        interpretationRequestId,
        referenceDatabasesVersions,
        reportUri,
        reportUrl,
        reportedVariants,
        softwareVersions,
        versionControl,
        comments=None,
        reportedStructuralVariants=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_4_0_0.InterpretedGenomeRD model.

        :param analysisId:
            This is the ID of the analysis carried out and is expected to be
            linked to the conditions and parameters         used to
            produce the clinical interpretation over this group of
            samples. It is critical to establish provenance.
            It is expected that this id can be used to retrieve an
            analysis in the decision support/ variant exploration
            tools
        :type analysisId: str
        :param companyName:
            Name of the company
        :type companyName: str
        :param interpretationRequestId:
            This is the ID of the clinical interpretation request
        :type interpretationRequestId: str
        :param referenceDatabasesVersions:
            This map should contains the version of the different DBs used in the
            process
        :type referenceDatabasesVersions: dict[str, str]
        :param reportUri:
            URI in the GEL file system where the company has upload files from
            this analysis
        :type reportUri: str
        :param reportUrl:
            URL where the results can be accessed in the company's web interface
        :type reportUrl: str
        :param reportedVariants:
            List of all reported variants
        :type reportedVariants: list[ReportedVariant]
        :param softwareVersions:
            This map should contains the version of the different software in the
            process
        :type softwareVersions: dict[str, str]
        :param versionControl:
            Model version number
        :type versionControl: ReportVersionControl
        :param comments:
            Comments about the report
        :type comments: None | list[str]
        :param reportedStructuralVariants:
            List of all reported structural variants
        :type reportedStructuralVariants: None | list[ReportedStructuralVariant]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "4.0.0"
